**Highly Efficient FFT for Exascale**

Joint project between:

**Innovative Computing Laboratory, University of Tennessee**

and

**Oak Ridge National Laboratory**

* * *

[TOC]

* * *

About
=====

The Highly Efficient FFT for Exascale (heFFTe) library is being developed as part of the Exascale
Computing Project (ECP), which is a joint project of the U.S. Department of Energy's Office of
Science and National Nuclear Security Administration (NNSA). HeFFTe delivers algorithms for
distributed fast-Fourier transforms in on a heterogeneous systems, targeting the upcoming exascale machines.


* * *

Documentation
=============

* Installation and a Doxygen documentation can be done with the CMake options `-D Heffte_ENABLE_DOXYGEN=ON`
* [Online Documentation](https://icl-utk-edu.github.io/heffte/)
* [HeFFTe installation](https://icl-utk-edu.github.io/heffte/md_doxygen_installation.html)
* [HeFFTe Website and Papers](https://www.icl.utk.edu/publications/fft-ecp-fast-fourier-transform)

* * *

Getting Help
============

For assistance with HeFFTe, email *heffte@icl.utk.edu* or start a [Github Issue](https://github.com/icl-utk-edu/slate/issues)

* * *

Contributing
============

The heFFTe project welcomes contributions from new developers.
Contributions can be offered through the standard Github pull request model.
We ask that you complete and submit a contributor agreement.

* * *

Resources
=========

* Visit the [Doxygen Documentation website](https://icl-utk-edu.github.io/heffte/)
* Visit the [HeFFTe website](http://icl.utk.edu/fft/) for more information about the heFFTe project.
* Visit the [ECP website](https://exascaleproject.org) to find out more about the DOE Exascale Computing Initiative.

* * *

Acknowledgments
===============

This research was supported by the Exascale Computing Project (17-SC-20-SC),
a collaborative effort of two U.S. Department of Energy organizations
(Office of Science and the National Nuclear Security Administration)
responsible for the planning and preparation of a capable exascale ecosystem,
including software, applications, hardware, advanced system engineering
and early testbed platforms, in support of the nation's exascale computing imperative.

This research uses resources of the Oak Ridge Leadership Computing Facility,
which is a DOE Office of Science User Facility supported under Contract DE-AC05-00OR22725.


* * *

License
=======

    Copyright (c) 2020, University of Tennessee
    All rights reserved.

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions are met:
        * Redistributions of source code must retain the above copyright
          notice, this list of conditions and the following disclaimer.
        * Redistributions in binary form must reproduce the above copyright
          notice, this list of conditions and the following disclaimer in the
          documentation and/or other materials provided with the distribution.
        * Neither the name of the University of Tennessee nor the
          names of its contributors may be used to endorse or promote products
          derived from this software without specific prior written permission.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
    ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
    WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
    DISCLAIMED. IN NO EVENT SHALL UNIVERSITY OF TENNESSEE BE LIABLE FOR ANY
    DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
    (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
    LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
    ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
    (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
    SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
